/**
 * Archivo principal el cual inicia la aplicacion EMA Libre.
 *
 * Archivo de inicio del sistema EMA Libre el mismo nos redirecciona
 * a la pantalla de las opciones dependiendo del tipo de configuracion
 * seleccionada, en caso de recibir el parametro update EMA inicia en modo
 * actualizador redireccionando index_actualizar.html (admin_update.js),
 * y si no recibe parametros, redirecciona al archivo index.html (admingui.js)
 * iniciando la interfaz grafica.
 *
 * LICENSE:  This file is part of EMA Libre.
 * EMA Libre is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EMA Libre is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EMA Libre.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @copyright  Copyright (c) 2019 GUGLER (http://www.gugler.com.ar)
 * @license    https://www.gnu.org/licenses/gpl-3.0.html GPL License
 * @version    3.0
 * @link       http://www.gugler.com.ar
 * @since      File available since Release 3.0
 */

// DECLARACIONES INICIALES

var gui = require('nw.gui'); // Se incluye NWJS
var str = gui.App.argv; // Se lee el parametro
var actualizar = str.indexOf('update'); // Se consulta si el parametro es update (0=SI)
gui.App.clearCache();
const voices = window.speechSynthesis.getVoices(); // Se consultan las voces del sistemas

if (actualizar === 0) {
  // Se inicia Ema Libre Actualizador
  gui.Window.open('./gui/index_actualizar.html', {
    position: 'center',
    width: 630,
    height: 400
  });
} else {
  // Se inicia Ema Libre Norma
  gui.Window.open('./gui/index.html', {
    frame: false,
    show: true,
    position: 'center',
    width: 140,
    height: 178,
    min_width: 140,
    min_height: 178,
    max_width: 140,
    max_height: 178
  });
}
